# Requirements

- Docker
    - Instructions to install Docker are available [here](https://docs.docker.com/get-docker/).
- Docker Compose
    - Instructions to install Docker Compose are available [here](https://docs.docker.com/compose/install/#install-compose).
- Docker with WSL2 on Windows
    - Instruction to install Docker are available [here](https://learn.microsoft.com/en-us/windows/wsl/tutorials/wsl-containers)

**Note:** You need to have a system running on either
- GNU/Linux
- Windows with WSL2 setup


If your system does not match any of the requirements above, you must install a virtual machine.
[This tutorial](https://www.wikihow.com/Install-Ubuntu-on-VirtualBox) may help you.

**Note:** By default, on a GNU/Linux host, Docker commands must be run using `sudo`. Two options are available for you in order to run the tool:
- Follow [these short steps](https://docs.docker.com/install/linux/linux-postinstall/#manage-docker-as-a-non-root-user) to allow your user to call Docker commands,
- Preface the scripts calls with `sudo`.

Your Docker installation should be allowed to allocate at least 3Go of RAM and 1Go of swap.
The container for VariCity might be automatically killed at its start otherwise.
On Linux host systems, Docker has no limitation on the resources it can allocate. On Windows systems, you can check for these settings: 
- If you use WSL2 on a Windows system, in [Docker Desktop for Windows](https://learn.microsoft.com/en-us/windows/wsl/wsl-config#main-wsl-settings).


A web browser is also needed to display the visualizations generated by VariCity. The visualization has been tested using:
- Google Chrome
- Mozilla Firefox
- Microsoft Edge